/* lan_dmz.js - API library for LAN DMZ configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,5OCT10,mvb  written. 
*/

/* add_ld_in_service.htm Start */
function fwAddLdInServicesValidate()
    {
    
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Invalid starting IP address for LAN users.';
    var errMsgL10n2 = 'for octet';
    var errMsgL10n3 = 'Invalid ending IP address for LAN users.';
    var errMsgL10n4 = 'LAN Users.';
    var errMsgL10n5 = 'Invalid starting IP address for DMZ users.';
    var errMsgL10n6 = 'Invalid ending IP address for DMZ users.';
    var errMsgL10n7 = 'DMZ Users';
    /* L10N Error Message Collection End */
    
	if (ipv4AddrOctetsValidate ('addLDInLanUserStart', 'IPD', false, true,
            errMsgL10n1, errMsgL10n2+" ", true) == false)
	    return false;
	if (ipv4AddrOctetsValidate ('addLDInLanUserFinish', 'IPD', false, true,
             errMsgL10n3, errMsgL10n2+" ", true) == false)
	    return false;
	if (ipRangeValidate ('addLDInLanUserStart','addLDInLanUserFinish', errMsgL10n4) == false)
		return false;
	if (ipv4AddrOctetsValidate ('addLDInWanUserStart', 'IPD', false, true,
            errMsgL10n5, errMsgL10n2+" ", true) == false)
	    return false;
	if (ipv4AddrOctetsValidate ('addLDInWanUserFinish', 'IPD', false, true,
             errMsgL10n6, errMsgL10n2+" ", true) == false)
	    return false;
	if (ipRangeValidate ('addLDInWanUserStart','addLDInWanUserFinish', errMsgL10n7) == false)
		return false;
    return true;
    }
    
function fwActionCheckLD ()
	{
	var selectedValue = comboSelectedValueGet  ('selFwAction');
	if (!selectedValue) return;
	switch (selectedValue)
		{
        case "ACCEPT_BY_SCHED_MATCH":
        case "DROP_BY_SCHED_MATCH":
			fieldStateChangeWr ('','','selSchedule','');
			break;
		case "ACCEPT":
			fieldStateChangeWr ('selSchedule','','','');
			break;
		default:
			fieldStateChangeWr ('selSchedule','','','');
			break;
		}
	}
function dropFieldSelectLanLD (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', 'addLDInLanUserFinish', '', 'addLDInLanUserStart');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', '', 'addLDInLanUserStart addLDInLanUserFinish');
   			break;
   		default:
   			fieldStateChangeWr ('', 'addLDInLanUserStart addLDInLanUserFinish', '', '');
   			break;
   		}
	}
function dropFieldSelectWanLD (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', 'addLDInWanUserFinish', '', 'addLDInWanUserStart');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', '', 'addLDInWanUserStart addLDInWanUserFinish');
   			break;
   		default:
   			fieldStateChangeWr ('', 'addLDInWanUserStart addLDInWanUserFinish', '', '');
   			break;
   		}
    }
function InitialSettingsLD ()
	{
	fwActionCheckLD ();
	var fldObj = document.getElementById('addLDInLanUser');
	if (!(fldObj.disable))
		dropFieldSelectLanLD (fldObj);
	var fldObj = document.getElementById('addLDInDmzUser');
	if (!(fldObj.disable))
		dropFieldSelectWanLD (fldObj);
	}
	
/* add_ld_in_service.htm End */

/* add_ld_out_service.htm Start */
function fwAddLdOutServicesValidate()
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Invalid starting IP address for LAN users.';
    var errMsgL10n2 = 'for octet';
    var errMsgL10n3 = 'Invalid ending IP address for LAN users.';
    var errMsgL10n4 = 'LAN Users.';
    var errMsgL10n5 = 'Invalid starting IP address for DMZ users.';
    var errMsgL10n6 = 'Invalid ending IP address for DMZ users.';
    var errMsgL10n7 = 'DMZ Users';
    /* L10N Error Message Collection End */

    
	if (ipv4AddrOctetsValidate ('addLDOutLanUserStart', 'IPD', false, true,
            errMsgL10n1,errMsgL10n2+" ", true) == false)
	    return false;
	if (ipv4AddrOctetsValidate ('addLDOutLanUserFinish', 'IPD', false, true,
            errMsgL10n3, errMsgL10n2+" ", true) == false)
	    return false;
	if (ipRangeValidate ('addLDOutLanUserStart','addLDOutLanUserFinish', errMsgL10n4) == false)
		return false;
	if (ipv4AddrOctetsValidate ('addLDOutWanUserStart', 'IPD', false, true,
             errMsgL10n5,errMsgL10n2+" ", true) == false)
	    return false;
	if (ipv4AddrOctetsValidate ('addLDOutWanUserFinish', 'IPD', false, true,
             errMsgL10n6, errMsgL10n2+" ", true) == false)
	    return false;
	if (ipRangeValidate ('addLDOutWanUserStart','addLDOutWanUserFinish', errMsgL10n7) == false)
		return false;
    return true;
    }
function fwActionCheck ()
	{
	var selectedValue = comboSelectedValueGet  ('selFwAction');
	if (!selectedValue) return;
	switch (selectedValue)
		{
        case "ACCEPT_BY_SCHED_MATCH":
        case "DROP_BY_SCHED_MATCH":
			fieldStateChangeWr ('','','selSchedule','');
			break;
		case "ACCEPT":
			fieldStateChangeWr ('selSchedule','','','');
			break;
		default:
			fieldStateChangeWr ('selSchedule','','','');
			break;
		}
	}
function dropFieldSelectLan (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', 'addLDOutLanUserFinish', '', 'addLDOutLanUserStart');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', '', 'addLDOutLanUserStart addLDOutLanUserFinish');
   			break;
   		default:
   			fieldStateChangeWr ('', 'addLDOutLanUserStart addLDOutLanUserFinish', '', '');
   			break;
   		}
	}
function dropFieldSelectWan (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', 'addLDOutWanUserFinish', '', 'addLDOutWanUserStart');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', '', 'addLDOutWanUserStart addLDOutWanUserFinish');
   			break;
   		default:
   			fieldStateChangeWr ('', 'addLDOutWanUserStart addLDOutWanUserFinish', '', '');
   			break;
   		}
    }
    
function InitialSettings ()
	{
	fwActionCheck ();
	var fldObj = document.getElementById('addLDOutLanUser');
	if (!(fldObj.disable))
		dropFieldSelectLan (fldObj);
	var fldObj = document.getElementById('addDWOutDmzUser');
	if (!(fldObj.disable))
		dropFieldSelectWan (fldObj);
	}
/* add_ld_out_service.htm End */



	
