/* session_limit.js - API library for session time limits validations */

/* Copyright 2011 TeamF1, Inc. */

/*
modification history 
------------------------
01a,12SEP11,mvb  written. 
*/

function sessionLimitValidate ()
	{
	 /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Invalid User Limit percentage: Please enter a value between 1 and 100';
    var errMsgL10n2 = 'Invalid User Limit percentage';
    var errMsgL10n3 = 'Invalid TCP Timeout value: Please enter a value between 0 and 4294967 Seconds';
    var errMsgL10n4 = 'Invalid TCP Timeout value';
    var errMsgL10n5 = 'Invalid UDP Timeout value: Please enter a value between 0 and 4294967 Seconds';
    var errMsgL10n6 = 'Invalid UDP Timeout value'
    var errMsgL10n7 = 'Invalid ICMP Timeout value: Please enter a value between 0 and 4294967 Seconds';
    var errMsgL10n8 = 'Invalid ICMP Timeout value';
    var errMsgL10n9 = 'Seconds';   
    var errMsgL10n10 = 'Invalid Time value: Please enter a value between 1 - 3600 Seconds';
    var errMsgL10n11 = 'Invalid Time value';
    /* L10N Error Message Collection End */	
	
	if(userLimitCheck () == false)
		return false;
		
	var selrdbIpObj = document.getElementById('rbdBlockIPToAdd');
	if(selrdbIpObj && !selrdbIpObj.diabled && selrdbIpObj.checked)
	    {
	    if (numericValueRangeCheck (document.getElementById ('txtTime0'), 1,
                                    errMsgL10n10, 1, 3600, true, errMsgL10n11+":", errMsgL10n9) ==false)
		return false;	    
	    }
    
    var selrdb2IpObj = document.getElementById('rbdBlockIPsAll');
	if(selrdb2IpObj && !selrdb2IpObj.diabled && selrdb2IpObj.checked)
	    {
	    if (numericValueRangeCheck (document.getElementById ('txtTime1'), 1,
                                    errMsgL10n10, 1, 3600, true, errMsgL10n11+":", errMsgL10n9) ==false)
		return false;	    
	    }
		
    if (numericValueRangeCheck (document.getElementById ('txtTcpTimeout'), 1, errMsgL10n3, 1, 432000, true, errMsgL10n4+":", errMsgL10n9) ==false)
		return false;
		
    if (numericValueRangeCheck (document.getElementById ('txtUdpTimeout'), 1, errMsgL10n5, 1, 432000, true, errMsgL10n6+":", errMsgL10n9) == false)
		return false;	
		
    if (numericValueRangeCheck (document.getElementById ('txtIcmpTimeout'), 1, errMsgL10n7, 1, 432000, true, errMsgL10n8+":", errMsgL10n9) == false)
		return false;
		
	return true;
	}


function userLimitCheck ()
	{
	var selValue = comboSelectedValueGet  ('selUserLimitParam');
	if (parseInt (selValue, 10) == 0)
		{
		var usrLimitObj = document.getElementById ('txtUserLimit');
		if (numericValueRangeCheck (usrLimitObj, 1, "Invalid User Limit percentage: Please enter a value between 1 and 100", 1, 100, true, "Invalid User Limit percentage:", "") == false)
			return false;
		}
	else
		{
		var usrLimitObj2 = document.getElementById ('txtUserLimit');
		if (numericValueRangeCheck (usrLimitObj2, 1, "Invalid User Limit : Please enter a value between 1 and 10000", 1, 10000, true, "Invalid User Limit :", "") == false)
			return false;
		}
	
	return true;
	}
	
function sessionLimitInit()
    {
    var selValue = radioCheckedValueGet ('SessionLimit.SessLimitEnable');
    if (!selValue) return;
    if(parseInt (selValue, 10) == 1)
        {
        fieldStateChangeWr ('','','','tblSessionLimt');
        sessionLimtCtrlFun ();
        }
    else
        {
        fieldStateChangeWr ('','tblSessionLimt','','');
        }
    }
    
function sessionLimtCtrlFun ()
    {
    var selSessionVal = comboSelectedValueGet ('selSessionLmtCtrl')
    if(!selSessionVal) return;
    switch (parseInt (selSessionVal, 10))
        {
        case 0: /*When Single IP Exceed*/
            fieldStateChangeWr ('','','rbdBlockIPToAdd txtTime0 rbdBlockIPsAll txtTime1','');
            blockIPCheck();
            break;
        case 1:
        default:
            fieldStateChangeWr ('rbdBlockIPToAdd txtTime0 rbdBlockIPsAll txtTime1','','','');
            break;
        }
    }

function blockIPCheck ()
    {
    var selrdbBlockIpVal = radioCheckedValueGet('SessionLimit.BlocKNewSession');
    selrdbBlockIpVal = parseInt (selrdbBlockIpVal, 10);
    if(selrdbBlockIpVal == 1)
        {
        fieldStateChangeWr ('txtTime1','','txtTime0','');
        }
    else if(selrdbBlockIpVal == 2)
        {
        fieldStateChangeWr ('txtTime0','','txtTime1','');
        }
    }    
